src/Entity/Borrowing.php
<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use App\Repository\BorrowingRepository;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * @ORM\Entity(repositoryClass=BorrowingRepository::class)
 */
class Borrowing
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;
   
    /**
     * @ORM\Column(type="datetime")
     */
    private $start_date;

    /**
     * @ORM\Column(type="datetime")
     */
    private $end_date;

    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;

    /**
     * @ORM\ManyToOne(targetEntity=StatutLocation::class, inversedBy="borrowings")
     */
    private $Statut_borrowing;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="Borrowing")
     */
    private $purchase;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $borrower;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $ref;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $refsent;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $refback;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $borrowingstatus; 
        

    public function getId(): ?int
    {
        return $this->id;
    }  

    public function getStartDate(): ?\DateTimeInterface
    {
        return $this->start_date;
    }

    public function setStartDate(\DateTimeInterface $start_date): self
    {
        $this->start_date = $start_date;

        return $this;
    }

    public function getEndDate(): ?\DateTimeInterface
    {
        return $this->end_date;
    }

    public function setEndDate(\DateTimeInterface $end_date): self
    {
        $this->end_date = $end_date;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getStatutBorrowing(): ?StatutLocation
    {
        return $this->Statut_borrowing;
    }

    public function setStatutBorrowing(?StatutLocation $Statut_borrowing): self
    {
        $this->Statut_borrowing = $Statut_borrowing;

        return $this;
    }

    public function getPurchase(): ?User
    {
        return $this->purchase;
    }

    public function setPurchase(?User $purchase): self
    {
        $this->purchase = $purchase;

        return $this;
    }

    public function getBorrower(): ?string
    {
        return $this->borrower;
    }

    public function setBorrower(string $borrower): self
    {
        $this->borrower = $borrower;

        return $this;
    }

    public function getRef(): ?string
    {
        return $this->ref;
    }

    public function setRef(string $ref): self
    {
        $this->ref = $ref;

        return $this;
    }

    public function getRefsent(): ?string
    {
        return $this->refsent;
    }

    public function setRefsent(string $refsent): self
    {
        $this->refsent = $refsent;

        return $this;
    }

    public function getRefback(): ?string
    {
        return $this->refback;
    }

    public function setRefback(string $refback): self
    {
        $this->refback = $refback;

        return $this;
    }

    public function getBorrowingstatus(): ?string
    {
        return $this->borrowingstatus;
    }

    public function setBorrowingstatus(string $borrowingstatus): self
    {
        $this->borrowingstatus = $borrowingstatus;

        return $this;
    }
  

  
}   

   

src/Form/BorrowingType.php
<?php

namespace App\Form;

use App\Entity\Borrowing;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class BorrowingType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('start_date')
            ->add('end_date')
            ->add('createdAt')
            ->add('Statut_borrowing')
            ->add('purchase')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Borrowing::class,
        ]);
    }
}

src/Controller/AdministratorController.php
<?php

namespace App\Controller;

use App\Entity\User;
use App\Entity\Genres;
use App\Entity\Vinyle;
use App\Entity\Borrowing;
use App\Entity\Interpreter;
use App\Form\UserType;
use App\Form\PersoType;
use App\Form\GenresType;
use App\Form\VinyleType;
use App\Form\BorrowingType;
use App\Form\InterpreterType;
use App\Form\Borrowing_ExpeditionType;
use App\Repository\UserRepository;
use App\Repository\GenresRepository;
use App\Repository\VinyleRepository;
use App\Repository\BorrowingRepository;
use App\Repository\InterpreterRepository;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;






/**
 * @Route("/admin")
 */
class AdministratorController extends AbstractController
{
    /*Index Adminstrateur*/

    /**
     * @Route("/", name="dashboard_index")
     */

    public function index_dashboard(){

        return $this->render('Administrator/dashboard.index.html.twig');
    }

    /* Gestion des Genres */

    /**
     * @Route("/genres", name="genres_index", methods={"GET"})
     */

    public function index_genres(GenresRepository $genresRepository): Response
    {
        return $this->render('Administrator/genres/index.html.twig', [
            'genres' => $genresRepository->findAll(),
        ]);
    }

    /**
     * @Route("/genre/new", name="genres_new", methods={"GET","POST"})
     */

    public function new_genre(Request $request): Response
    {
        $genre = new Genres();
        $form = $this->createForm(GenresType::class, $genre);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($genre);
            $entityManager->flush();

            return $this->redirectToRoute('genres_index');
        }

        return $this->render('Administrator/genres/new.html.twig', [
            'genre' => $genre,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/genre/{id}", name="genres_show", methods={"GET"})
     */

    public function show_genres(Genres $genre): Response
    {
        return $this->render('Administrator/genres/show.html.twig', [
            'genre' => $genre,
        ]);
    }

    /**
     * @Route("/genre/{id}/edit", name="genres_edit", methods={"GET","POST"})
     */

    public function edit_genre(Request $request, Genres $genre): Response
    {
        $form = $this->createForm(GenresType::class, $genre);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('genres_index');
        }

        return $this->render('Administrator/genres/edit.html.twig', [
            'genre' => $genre,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/genre/{id}", name="genres_delete", methods={"DELETE"})
     */

    public function delete_genre(Request $request, Genres $genre): Response
    {
        if ($this->isCsrfTokenValid('delete'.$genre->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($genre);
            $entityManager->flush();
        }

        return $this->redirectToRoute('genres_index');
    }

    /* Gestion des Interprètres */

    /**
     * @Route("/interpreter", name="interpreter_index", methods={"GET"})
     */

    public function index_interpreter(Request $request,InterpreterRepository $interpeterRepository,PaginatorInterface $paginator )
    {   
        
        $donnees = $this->getDoctrine()->getRepository(Interpreter::class)->findAll();
        $interpreters = $paginator->paginate(
            $donnees, // Requête contenant les données à paginer (ici nos articles)
            $request->query->getInt('page', 1), // Numéro de la page en cours, passé dans l'URL, 1 si aucune page
            2 // Nombre de résultats par page        
        );              
          
        return $this->render('Administrator/interpreter/index.html.twig', [            
            'interpreters'=>$interpreters 
        ]);
    }

    /**
     * @Route("/interpreter/new", name="interpreter_new", methods={"GET","POST"})
     */

    public function new_interpreter(Request $request): Response
    {
        $interpreter = new Interpreter();
        $form = $this->createForm(InterpreterType::class, $interpreter);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($interpreter);
            $entityManager->flush();

            return $this->redirectToRoute('interpreter_index');
        }

        return $this->render('Administrator/interpreter/new.html.twig', [
            'interpreter' => $interpreter,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/interpreter/{id}", name="interpreter_show", methods={"GET"})
     */
    public function show_interpreter(Interpreter $interpreter): Response
    {
        return $this->render('Administrator/interpreter/show.html.twig', [
            'interpreter' => $interpreter,
        ]);
    }

    /**
     * @Route("/interpreter/{id}/edit", name="interpreter_edit", methods={"GET","POST"})
     */
    public function edit_interpreter(Request $request, Interpreter $interpreter): Response
    {
        $form = $this->createForm(InterpreterType::class, $interpreter);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('interpreter_index');
        }

        return $this->render('Administrator/interpreter/edit.html.twig', [
            'interpreter' => $interpreter,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/interpreter/{id}", name="interpreter_delete", methods={"DELETE"})
     */
    public function delete_interpreter(Request $request, Interpreter $interpreter): Response
    {
        if ($this->isCsrfTokenValid('delete'.$interpreter->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($interpreter);
            $entityManager->flush();
        }

        return $this->redirectToRoute('interpreter_index');
    }

    /* Gestions des Vinyles */

    /**
     * @Route("/vinyle", name="vinyle_index", methods={"GET"})
     */

    public function index_vinyle(Request $request, PaginatorInterface $paginator)
    {
        $donnees = $this->getDoctrine()->getRepository(Vinyle::class)->findAll();
        $vinyles = $paginator->paginate(
            $donnees, // Requête contenant les données à paginer (ici nos articles)
            $request->query->getInt('page', 1), // Numéro de la page en cours, passé dans l'URL, 1 si aucune page
            5 // Nombre de résultats par page
        );   
        return $this->render('Administrator/vinyle/index.html.twig', [
            'vinyles' => $vinyles,
        ]);
    }

    /**
     * @Route("/vinyle/new", name="vinyle_new", methods={"GET","POST"})
     */

    public function new_vinyle(Request $request): Response
    {
        $vinyle = new Vinyle();
        $form = $this->createForm(VinyleType::class, $vinyle);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($vinyle);
            $entityManager->flush();

            return $this->redirectToRoute('vinyle_index');
        }

        return $this->render('Administrator/vinyle/new.html.twig', [
            'vinyle' => $vinyle,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/vinyle/{id}", name="vinyle_show_administrator", methods={"GET"})
     */

    public function show_vinyle(Vinyle $vinyle): Response
    {
        return $this->render('Administrator/vinyle/show.html.twig', [
            'vinyle' => $vinyle,
        ]);
    }

    /**
     * @Route("/vinyle/{id}/edit", name="vinyle_edit_administrator", methods={"GET","POST"})
     */

    public function edit_vinyle(Request $request, Vinyle $vinyle): Response
    {
        $form = $this->createForm(VinyleType::class, $vinyle);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('vinyle_index');
        }

        return $this->render('Administrator/vinyle/edit.html.twig', [
            'vinyle' => $vinyle,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/vinyle/{id}", name="vinyle_delete", methods={"DELETE"})
     */

    public function delete(Request $request, Vinyle $vinyle): Response
    {
        if ($this->isCsrfTokenValid('delete'.$vinyle->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($vinyle);
            $entityManager->flush();
        } 

        return $this->redirectToRoute('vinyle_index');
    }

    /* Gestions des Utilisateurs */

    /**
     * @Route("/user", name="user_index", methods={"GET"})
     */

    public function index_user(UserRepository $userRepository): Response
    {
        return $this->render('Administrator/user/index.html.twig', [
            'users' => $userRepository->findAll(),
        ]);
    }

    /**
     * @Route("/user/new", name="user_new", methods={"GET","POST"})
     */

templates/Administrator/borrowing/_delete_form.html.twig
<form method="post" action="{{ path('borrowing_delete', {'id': borrowing.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ borrowing.id) }}">
    <button class="btn btn-primary">Supprimer</button>
</form>

templates/Administrator/borrowing/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn btn-success">{{ button_label|default('Sauvegarder') }}</button>
{{ form_end(form) }}

templates/Administrator/borrowing/edit.html.twig
{% extends 'base_admin.html.twig' %}

{% block title %}Edition commande{% endblock %}

{% block body %}
      <section id="borrowing-index" class="container-fluid">
		<section class="container">
			<header class="row">
				<div class="col-12">
                    <h1 class="service">Edition commande</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12">    
                    {{ include('Administrator/borrowing/_form.html.twig', {'button_label': 'mise à jour'}) }}
                    <a href="{{ path('borrowing_index') }}">retour à la liste</a>
                    {{ include('Administrator/borrowing/_delete_form.html.twig') }}
                </div>
            </div>
        </section>
    </section>                
{% endblock %}

templates/Administrator/borrowing/expedition.html.twig
{% extends 'base_admin.html.twig' %}
{% block title %}Expédition{% endblock %}
{% block body %}
    <section id="borrowing-expedition" class="container-fluid">
		<section class="container">
			<header class="row">
				<div class="col-12">	  
                    <h1 class="service">Compte</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12">            
                    <table class="table">
                        <thead>
                            <tr>
                                <th>Emprunteur</th>
                                <th>Référence Commande</th>
                                <th>Date de commande</th>
                                <th>Date limite de retour</th>
                            </tr>
                        </thead>    
                        <tbody>
                            <tr>                
                                <td>{{borrowing.borrower}}</td>    
                                <td>{{borrowing.ref}}</td>             
                                <td>{{ borrowing.startDate ? borrowing.startDate|date('Y-m-d H:i:s') : '' }}</td>  
                                <td>{{ borrowing.endDate ? borrowing.endDate|date('Y-m-d H:i:s') : '' }}</td>
                            </tr> 
                        </tbody>
                    </table> 
                </div>
                <div class="col-12">     
                    <h1 class="service">Informations d'Expédition</h1>
	                {{ form_start(form) }}     	
                    {{ form_row(form.borrowingstatus, { 'label': 'Statut Commande' }) }}
                    {{ form_row(form.refsent, { 'label': 'Référence Envoi Chronopost' }) }}    	   	    	
	                <button class="btn">{{ button_label|default('Valider') }}</button>
	                {{ form_end(form) }}    
                    <a href="{{ path('borrowing_index') }}">Retour liste</a>
                </div>
            </div>
        </section>
    </section>                
{% endblock %}
{% block javascripts %}
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
{% endblock %}

templates/Administrator/borrowing/index.html.twig
{% extends 'base_admin.html.twig' %}
{% block title %}tableau de bord Admin Commande{% endblock %}
{% block body %}
    <section id="borrowing-index" class="container-fluid">
		<section class="container">
			<header class="row">
				<div class="col-12">	  
                    <h1 class="service">Gestion des commandes</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12"> 
                    <table class="table">
                        <thead>
                            <tr>
                                <th>Id</th>
                                <th>Reférence Commande</th>               
                                <th>Emprunteur</th>                
                                <th>Date Commande</th>
                                <th>Date Limite Retour</th>
                                <th>Reférence Expedition</th>
                                <th>Reférence Retour</th>              
                                <th>Statut</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                        {% for borrowing in borrowings %}
                            <tr>
                                <td>{{ borrowing.id }}</td>
                                <td>{{ borrowing.ref }}</td>                
                                <td>{{ borrowing.borrower }}</td>               
                                <td>{{ borrowing.startDate ? borrowing.startDate|date('Y-m-d H:i:s') : '' }}</td>
                                <td>{{ borrowing.endDate ? borrowing.endDate|date('Y-m-d H:i:s') : '' }}</td>
                                <td>{{ borrowing.refsent }}</td>
                                <td>{{ borrowing.refback }}</td>                
                                <td>{{ borrowing.borrowingstatus}}</td>
                                <td>
                                    <a href="{{ path('borrowing_show', {'id': borrowing.id}) }}">Voir</a>
                                    <a href="{{ path('borrowing_expedition', {'id': borrowing.id}) }}">Expédition</a>
                                    <a href="{{ path('borrowing_empty', {'id': borrowing.id, 'ref': borrowing.ref}) }}">Clôture</a>
                                    <a href="{{ path('borrowing_edit', {'id': borrowing.id}) }}">Mise à Jour</a>   
                                </td>
                            </tr>
                        {% else %}
                            <tr>
                                <td colspan="9">no records found</td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </section>
    </section>                
{% endblock %}
{% block javascripts %}
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
{% endblock %}  

templates/Administrator/borrowing/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Nouvelle commande{% endblock %}

{% block body %}
     <section id="borrowing-index" class="container-fluid">
		<section class="container">
			<header class="row">
				<div class="col-12">
                    <h1 class="service">Creation nouvelle commande</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12">    
                    {{ include('Administrator/borrowing/_form.html.twig') }}
                    <a href="{{ path('borrowing_index') }}">back to list</a>
                </div>
            </div>
        </section>
    </section>         
{% endblock %}

templates/Administrator/borrowing/show.html.twig
{% extends 'base_admin.html.twig' %}

{% block title %}Commande{% endblock %}

{% block body %}
    <section id="borrowing-show" class="container-fluid">
		<section class="container">
			<header class="row">
				<div class="col-12">
                    <h1 class="service">Commande</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12">
                    <table class="table">                        
                        <thead>
                            <tr>
                                <th>Id</th>                   
                                <th>Date de commande</th>
                                <th>Date limite de retour</th>
                            </tr>
                        </thead>
                        <tbody>                
                            <tr>                
                                <td>{{ borrowing.id }}</td>  
                                <td>{{ borrowing.startDate ? borrowing.startDate|date('Y-m-d H:i:s') : '' }}</td>     
                                <td>{{ borrowing.endDate ? borrowing.endDate|date('Y-m-d H:i:s') : '' }}</td>
                            </tr>
                        </tbody>
                    </table>                          
                    <a href="{{ path('borrowing_index') }}">Retour list</a>
                    <a href="{{ path('borrowing_edit', {'id': borrowing.id}) }}">mise à jour</a>
                </div>
            </div>
        </section>
    </section>   
{{ include('Administrator/borrowing/_delete_form.html.twig') }}
{% endblock %}